version: '3.7'

services: 
  redis-master:
    image: redis
    container_name: redis-master
    restart: unless-stopped
    command: redis-server /usr/local/etc/redis/redis.conf
    ports: 
      - "6379:6379"
    networks: 
      - shared_server_network
    environment:
      TZ: ${TIMEZONE}
    volumes: 
      - ./conf/master.conf:/usr/local/etc/redis/redis.conf
  
  redis-slave-1:
    image: redis
    container_name: redis-slave-1
    ports: 
      - "6380:6379"
    command: redis-server --slaveof redis-master 6379
    environment:
      TZ: ${TIMEZONE}
    networks: 
      - shared_server_network

  redis-slave-2:
    image: redis
    container_name: redis-slave-2
    ports: 
      - "6381:6379"
    command: redis-server --slaveof redis-master 6379
    environment:
      TZ: ${TIMEZONE}
    networks: 
      - shared_server_network

  redis-sentinel-1:
    image: redis
    container_name: redis-sentinel-1
    ports: 
      - "26379:26379"
    restart: unless-stopped
    command: redis-sentinel /usr/local/etc/redis/redis-sentinel.conf
    environment:
      TZ: ${TIMEZONE}
    volumes: 
      - ./conf/sentinel_1.conf:/usr/local/etc/redis/redis-sentinel.conf
    networks: 
      - shared_server_network

  redis-sentinel-2:
    image: redis
    container_name: redis-sentinel-2
    ports: 
      - "26380:26379"
    restart: unless-stopped
    command: redis-sentinel /usr/local/etc/redis/redis-sentinel.conf
    environment:
      TZ: ${TIMEZONE}
    volumes: 
      - ./conf/sentinel_2.conf:/usr/local/etc/redis/redis-sentinel.conf
    networks: 
      - shared_server_network

  redis-sentinel-3:
    image: redis
    container_name: redis-sentinel-3
    ports: 
      - "26381:26379"
    restart: unless-stopped
    command: redis-sentinel /usr/local/etc/redis/redis-sentinel.conf
    environment:
      TZ: ${TIMEZONE}
    volumes: 
      - ./conf/sentinel_3.conf:/usr/local/etc/redis/redis-sentinel.conf
    networks: 
      - shared_server_network

networks:
  shared_server_network:
    driver: overlay
    external: true
    name: $SHARED_NETWORK